//////////////////////////////////////////////////
//
//                      ppa-r
//  point process analysis system: pair correlation
//
//      Copyright  October 2001 by TAKENAKA, A.
//           rev.  November 2004

#if !defined (___PLOT_AREA_H)
#define ___PLOT_AREA_H

#include <string>
#include <vector>
#include <utility>

#include "r_x_array.h"
#include "pointlist.h"

//////////////////////////////
//
//  Plot area class calculates pair correlation for loaded point data.
//
//  When a set of data is given, correlation within given
//  spatial point pattern is calculated.
//
//  When two sets of data are given, correlation between the 
//  two sets of points is calculated..
//
//  To use this class, call loadPoints() and calc_r(), and then
//  call getResults to get the results.

class PlotArea
{
  public:

    PlotArea(void);

    bool loadPoints(const char* file1, const char* file2 = NULL);
    const r_X_Array& getResults(void);
    bool  calc_cor(double r_unit, double r_upto);

  protected:  //  protected methods.

    void   initArray(void);
//    int    r_to_index(double r);
    double get_w(double d);  //  Epanechnikov kernel
    double get_s(double x);  //  Ohser's edge correction

  protected:  //  data members.

    PointList Points1;
    PointList Points2;

    double Density1;
    double Density2;
    double MeanDensity;
    double Delta;  //  width of Epanechnikov kernel.

    double R_Upto;
    double R_Unit;
    int    MaxR_Index;

    XY     AreaSize;
    double Area;
    double Perimeter;

    r_X_Array ResultsArray;
};

#endif
